jQuery.sap.require("sas.stress.wkbench.ViewManager");
jQuery.sap.require("sas.stress.wkbench.StressUtil");
jQuery.sap.require("sas.stress.wkbench.StressAPI");

sap.ui.controller("sas.stress.wkbench.view.TaskSASScriptParameters",{
	onInit: function () {
		var view = this.getView();
		var viewData = view.getViewData();

		this.task=viewData.task;
		var script=viewData.script;
		// set the model
		// the script == ..._fromJSON, we need to  toJSON it
		var defaultParameters=[];
		_.each(script._parameters,function(parameter){
			var defaultParameter={name:"",value:"",description:""};

			defaultParameter.name=parameter.name;
			defaultParameter.value=parameter.value;
			defaultParameter.description=parameter.description;

			defaultParameters.push(defaultParameter);
		});
		var thescript={
			id:script.id,
			key:script.key,
			name:script.name,
			version:script.version,
			description:script.description,
			code:script.code,

			defaultParameters:defaultParameters,

			created:script.created,
			createdByUserId:script.createdByUserId,
			updated:script.updated,
			updatedByUserId:script.updatedByUserId
		};
		var model=new sap.ui.model.json.JSONModel({script:thescript});
		view.parametersTable.setModel(model);

		view.setModel(model);
	},
	_parameterLiveChange:function(){

	},
	runSASScriptTask:function(e){
		var view=this.getView();
		var data=view.parametersTable.getModel().getData();
		var that=this;

		// run the task
		if (view.okButton.getEnabled() === true) { //S1467014 This prevents doubleclicks
			view.okButton.setEnabled(false);
			sas.stress.wkbench.StressAPI.runTask(this.task, data.script)
				.done(function (data) {
					that.task.script = data.script;
					view.fireEvent(view.getId() + "_CLOSING", {
						"view": view,
						"action": "DONE",
						response: "Done",
						data: data
					});
				})
				.fail(function (e) {
					view.fireEvent(view.getId() + "_CLOSING", {"view": view, "action": "DONE", response: e});
				})
				.always(function () {
				view.okButton.setEnabled(true);
			});
		}
		//view.fireEvent(view.getId() + "_CLOSING", { "view": view, "action": "OK" });
	},
	cancel:function(e){
		var view = this.getView();
		view.fireEvent(view.getId() + "_CLOSING", { "view": view, "action": "CANCEL" });
	}
});